package com.picfun.wifiaudio;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.Timer;
import java.util.TimerTask;
import java.util.ArrayList;
import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class WiFiAudio extends Activity {
	// フィールド変数の定義
	private Button Connect, End;
	private EditText Host;
	private ListView Title;
	private TextView State;
	private ArrayList<String> list;
	private ArrayAdapter<String> adapter;
	static Timer timer;	
	static int ContFlag1, ContFlag2, i, j, Index;
	static byte[][] TitleList = new byte[15][100];
	static String[] TitleStr = new String[100];
	static String Selected;
	// ソケット関連変数定義
	Handler handler= new Handler();	
	static Socket socket = null;
	static DataOutputStream out;
	static DataInputStream in;	
	private byte[] Buffer = new byte[4000];
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// キーボードを隠し、画面縦に固定
		getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
		this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		// 画面の表示
		setContentView(R.layout.activity_wi_fi_audio);
        //コンポーネントのインスタンス取得
        Connect = (Button)this.findViewById(R.id.Connect);		// 接続ボタン
        Connect.setBackgroundColor(Color.GREEN);				// 緑指定
        End = (Button)this.findViewById(R.id.End);				// 終了ボタン
        End.setBackgroundColor(Color.GRAY); 					// 灰色指定
        Host = (EditText)this.findViewById(R.id.editText1);		// IPアドレス設定
        State = (TextView)this.findViewById(R.id.textView1);	// 状態メッセージ
        /**** ファイルリストビュー　　****/
        Title = (ListView)this.findViewById(R.id.listView1);	// ファイルリスト
        Title.setBackgroundColor(Color.WHITE);					// 背景色白
        list = new ArrayList<String>();
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, list);        
        Title.setAdapter(adapter);        
        // ボタンイベント組み込み
        Connect.setOnClickListener((OnClickListener) new connect());
        End.setOnClickListener((OnClickListener) new release());
        Title.setOnItemClickListener((OnItemClickListener) new selection());
        Index = 0;
	}
    /**** アプリ遷移イベント関連メソッド ***************/
	@Override
	public void onStart() {
		super.onStart();
	}
	@Override
	protected void onStop(){
		super.onStop();
		try{
			timer.cancel();					// 受信周期タイマ停止
			if(socket != null){	
				socket.close();				//ソケット終了
				socket = null;
			}
		}catch (IOException e){
		}
	}
    /**** 接続ボタンイベント処理サブクラス *************/
    class connect implements OnClickListener{
    	public void onClick(View v){
    		/**** 接続処理のスレッドを生成し起動  ***/
    		Thread clientThread = new Thread(new ClientThread());
    		clientThread.start();	    		
    	}
    }
    /***** 終了ボタン処理サブクラス ********************/
    class release implements OnClickListener{
    	public void onClick(View v){
    		timer.cancel();							// 周期タイマ停止
    		try{
    			out.writeBytes("SNE");				// 終了コマンド送信
    			socket.close();
    			socket = null;
    		}catch(IOException e){
    		}
    		finish();									// アプリ終了
    	}
    }
    /***** 曲選択 **************************************/ 
    class selection implements OnItemClickListener{	
    	public void onItemClick(AdapterView<?> v, View iv, int pos, long id){
    		TextView text = (TextView)iv;
    		Selected = (String)text.getText();		// 選択したファイル名を取得
    		ContFlag1 = 1;							// 送信要求フラグセット
    	}    	
    }  
    /**** 端末接続実行スレッド *************************/
    public class ClientThread implements Runnable{
    	public void run(){
    		
    		handler.post(new Runnable(){
    			public void run(){
    				State.setText("接続開始");
    			}
    		});
    		/*****　IPアドレスとポート番号を取得 ****************/
    		String address = Host.getText().toString();
    		int port = 2000; 		
    		/**** 接続実行 ************/
   			try{
   				socket = new Socket(address, port); 	
   				handler.post(new Runnable(){
   					public void run(){
						State.setTextColor(Color.BLACK);  						
   						State.setText("接続完了");
   					}
   				});
   				/**** ストリームを取得 **********/
   		    	out = new DataOutputStream(socket.getOutputStream());
   		    	in = new DataInputStream(socket.getInputStream());  		    	
   		    	/******* リスト要求とリスト表示 ****************/
   		    	Index = 0;
  		    	/**** タイマ起動と周期起動タスクのスタート ****/
   		    	timer = new Timer(true);
   		    	timer.schedule(new TimerTask(){
	    			@Override
	    			public void run(){
	    				/**** 周期起動のスレッドを生成し起動 ***/
		   		    	Thread getList = new Thread(new getList());
						getList.start();			// 受信のスレッド開始
	    			}
   				}, 100, 500);						// 最初0.1秒待ち、以後0.5秒周期 
   		    	/***** ファイルリスと要求送信 *****/
  		    	out.writeBytes("SFE");				// ファイルリスト要求送信
  		    	out.writeBytes("SC1E");				// 目印LED制御送信
    		}catch (IOException e){
        		handler.post(new Runnable(){
        			public void run(){
						State.setTextColor(Color.RED);       				
        				State.setText("接続失敗");
        			}
        		});   			
    		}
    	}
    } 
    /**** 周期的にリストを受信するスレッド *************/
    public class getList implements Runnable{
   		public void run(){
   			int count = 0;

   			try{
				i = 0;										// カウンタリセット
   				/** 受信データ有無のチェック　***/
   				count = in.available();						// 受信データ個数取得
   				/*** 受信データの処理 ***/	
   				if(count > 0){								// 受信データありの場合
   					in.read(Buffer);						// 受信データをBufferに取り出し
   					/**** 受信データ処理 ****/
   					while(i < count){
   						/*** ファイル名取り出し格納 ***/
   						if((Buffer[i] == 0x4D) && (Buffer[i+1] == 0x46))	// MFサーチ
   						{
							for(j=0; j<12; j++){							// 1個のファイル名コピー
								TitleList[j][Index] = Buffer[i+j+2];
							}
   							i += 12;
   							if(Index < 100){								// 最大100個で制限
   								Index++;
   							}
   						}
   						else
   							i++;
   					}
					/*** ファイルリスト表示更新処理 ****/
					handler.post(
						new Runnable()
   						{
   							public void run()
   							{
   								/*** 受信メッセージ ***/
   								State.setText("データ受信" + Integer.toString(Index) + "曲");
   								/** ファイルリスト更新 ***/							
   								for(i=0; i<Index; i++){
   									TitleStr[i] = "";
   									for(j=0; j<13; j++){		// ファイル名コピー
   										TitleStr[i] += (char)(TitleList[j][i]);
   									}
    								list.add(TitleStr[i]); 		// リストビュー追加
   								}
   								Title.setAdapter(adapter); 		// リストビュー表示更新
   							}
   						}
					);
	   			}
   				/***** 曲が選択された場合の送信処理 *****/				
   				if(ContFlag1 == 1){
   					ContFlag1 = 0;
   					out.writeBytes("SG"+Selected + "E");		// 曲選択制御送信
   				}
   			
   	   		}catch(IOException e){
        		handler.post(new Runnable(){
        			public void run(){
						State.setTextColor(Color.RED);       				
        				State.setText("送受信失敗");
        			}
        		});
    		}
   		}
    }
}
